<?php
defined("td_erp") or exit("Access Denied");

//取出当前城市数组
function getThisArea(&$areaList,$areaId){
	if(!is_array($areaList) || !is_numeric($areaId)){
		return false;
	}
	foreach($areaList as $a){
		if($a['areaId']==$areaId){
			return $a;
		}
	}
	return false;
}

//获取城市列表，$areaId为某一个父城市或省份的ID值；$level指定要取出第几级的值，默认0取出最底级城市，1取出当前城市的下一级城市，2为取出直辖市和省级，-1为取出当前城市的上一级城市；$self结果中是否包含自己
function getArea(&$areaArray,$areaId,$level=0,$self=false)
{
    if(!is_array($areaArray))
    {
        return false;
    }
    $area=array();
	if($self){
		$temp=getThisArea($areaArray,$areaId);
		if(is_array($temp)){
			$area[]=$temp;
		}
	}
    if($level==0)
    {
        return getNextArea($areaArray,$areaId,$area);
    }
    else if($level==1)
    {
        foreach($areaArray as $v)
        {
            if($v["parentId"]==$areaId)
            {
                $area[]=$v;
            }
        }
    }
    else if($level==2)
    {
        foreach($areaArray as $v)
        {
            if($v["parentId"]==0)
            {
                $area[]=$v;
            }
        }
    }
    else
    {
        foreach($areaArray as $v)
        {
            if($v["areaId"]==$areaId)
            {
                $area[]=$v;
            }
        }
    }
    return count($area)==0?false:$area;
}
function getNextArea(&$areaArray,$areaId,$area)
{
    if(!is_array($areaArray))
    {
        return false;
    }
    foreach($areaArray as $v)
    {
        if($v["parentId"]==$areaId)
        {
            $area[]=$v;
            $area=getNextArea($areaArray,$v["areaId"],$area);
        }
    }
    return $area;
}

//获取地区SELECT，$parentId为指定父区域的ID值，为0时取省及省级直辖市
function areaSelect(&$areaList,$parentId=0,$name='',$id='',$js='',$checkedId=0){
	if(!is_array($areaList)){
		return false;
	}
	$parentId=(!is_numeric($parentId) || (int)($parentId)<1)?0:(int)($parentId);
	$name=preg_match("/[a-z]{1,20}/i",$name)?$name:'area';
	$id=preg_match("/[a-z]{1,20}/i",$id)?$id:'area';
	$checkedId=is_numeric($checkedId)?$checkedId:0;
	$select=<<<html
		<select name="{$name}" id="{$id}" onChange="{$js}"><option value="0">---请选择---</option>
html;
	if($parentId==0){
		$area=getArea($areaList,0,2);
	}else{
		$area=getArea($areaList,$parentId,1);
	}
	if(!is_array($area)){
		return false;
	}
	foreach($area as $a){
		$checked=$checkedId==$a['areaId']?" selected":'';
		$select.="<option value=\"{$a['areaId']}\" {$checked}>{$a['areaName']}</option>";
	}
	$select.="</select>";
	return $select;
}

//给出区域的ID，得出此区域的最顶级区域
function getTopArea(&$areaArray,$areaId)
{
	if(!is_array($areaArray))
    {
    	return false;
    }
    foreach($areaArray as $t)
    {
    	if($t["areaId"]==$areaId && $t["parentId"]==0)
        {
        	return $t;
        }
        else if($t["areaId"]==$areaId)
        {
			$thisArea=$t;
			$parent=$thisArea['arrParentId'];
			$parent=explode(',',$parent);
			foreach($parent as $p){
				if($p=='0'){
					continue;
				}
				$thisArea=getThisArea($areaArray,$p);
				if(is_array($thisArea) && $thisArea['parentId']==0){
					return $p;
				}
			}
			return false;
        }
    }
    return false;
}

//给出低层区域的ID，得出与此区域相关的区域级别显示，例如：给出梁园区的ID值，得出下面的字符串，河南省－》商丘市－》梁园区
function getAreaLevel($areaArray,$areaId,$areaLevel="")
{
	if(!is_array($areaArray) || !is_numeric($areaId) || intval($areaId)===0)
    {
    	return false;
    }
    if(!is_array($areaLevel))
    {
    	$areaLevel=array();
    }
    $areaLevel=getAreaLevelStart($areaArray,$areaId,$areaLevel);
    $area="";
    for($i=count($areaLevel)-1; $i>=0; $i--)
    {
    	$area.="{$areaLevel[$i]['areaName']} ";
    }
    $area=trim($area," ");
    return $area;
}
function getAreaLevelStart($areaArray,$areaId,$areaLevel)
{
	if(!is_array($areaArray) || intval($areaId)===0)
    {
    	return false;
    }
    foreach($areaArray as $t)
    {
    	if($t["areaId"]==$areaId && $t["parentId"]!=0)
        {
        	$areaLevel[]=$t;
            $areaLevel=getAreaLevelStart($areaArray,$t["parentId"],$areaLevel);
            break;
        }
        else if($t["areaId"]==$areaId)
        {
        	$areaLevel[]=$t;
            break;
        }
    }
    return $areaLevel;
}
?>