<?php
!defined("td_erp")?exit("Access Denied"):'';

//获取URI的通用方法
function request_uri() 
{ 
	if (isset($_SERVER['REQUEST_URI'])){ 
		$uri = $_SERVER['REQUEST_URI']; 
	}else{ 
		if (isset($_SERVER['argv'])){ 
			$uri = $_SERVER['PHP_SELF'] .'?'. $_SERVER['argv'][0]; 
		}else{ 
			$uri = $_SERVER['PHP_SELF'] .'?'. $_SERVER['QUERY_STRING']; 
		} 
	}
	$uri=str_replace(array('<','>'),array('&lt;','&gt;'),$uri);
	return $uri; 
} 

//解析地址栏url格式的字符串到数组，$urlDecode是否要对获取的值进行RAWURLDECODE解码，默认false，不解码
function parseUrl($url="",$urlDecode=false)
{
	if(isNull($url))
    {
    	return false;
    }
    $url=explode("&",$url);
    $result=array();
    foreach($url as $u)
    {
    	$temp=array("","");
    	$temp=explode("=",$u);
    	$result[$temp[0]]=$urlDecode?rawurldecode($temp[1]):$temp[1];
        $temp=null;
    }
    return $result;
}

//删除字符串中的HTML标记
function deleteHTML($str)
{
	if(isNull($str))
    {
    	return false;
    }
    $str=strip_tags($str);
    return $str;
}


//自定义的字符编码转换，$str可接收数组，startCode指str当前的编码，endCode指需要转向的目标编码
function myIconv($str,$startCode="utf-8",$endCode="gbk")
{
	if(isNull($str) || isNull($startCode) || isNull($endCode))
	{
		return $str;
	}
	if(is_array($str))
	{
		foreach($str as $key=>$p)
		{
			if(is_array($p))
			{
				$str[$key]=myIconv($str[$key],$startCode,$endCode);
			}
			else
			{
				$str[$key]=mb_convert_encoding($p,$endCode,$startCode);
			}
		}
	}
	else
	{
		$str=mb_convert_encoding($str,$endCode,$startCode);
	}
	return $str;
}

//二维数组排序，$arr是要排序的数组，$keys是排序依据的元素索引值，$order是排序方式，默认按指定的索引升序排序
function array_sort(&$arr,$keys,$order='asc')
{
    $keysvalue=$new_array=array();
    foreach($arr as $k=>$v)
    {
        $keysvalue[$k]=$v[$keys];
    }
    if($order=='asc')
    {
        asort($keysvalue);
    }else{
        arsort($keysvalue);
    }
    reset($keysvalue);
    foreach($keysvalue as $k=>$v)
    {
        $new_array[$k]=$arr[$k];
    }
    return $new_array;
}

//导出为EXCEL，$sql必须，$fileName需要生成的文件名，默认空即随机生成
function exportExcel($sql,$title="",$fileName="")
{
	global $td_config,$query,$conn,$schoolList,$adminUnit,$positionList,$countryObj,$teachObj,$gradeList;
    if(isNull($sql) || preg_match("/(insert)|(delete)|(update)|(drop)|(truncate)/i",$sql))
    {
    	return false;
    }
    $query->query($sql,1,false);
	$columnCount=$query->result->columnCount();
	
	$xlsFileName=isNull($fileName)?fileName(8):$fileName;
	$file_ending="xls";
	header("Content-Type: application/vnd.ms-excel");
    header("Pragma: public");
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
    header("Content-Type: application/force-download");
    header("Content-Type: application/octet-stream");
    header("Content-Type: application/download");
    header("Content-Disposition: attachment;filename={$xlsFileName}.{$file_ending}");
    header("Content-Transfer-Encoding: binary ");
	echo myIconv("<style type=\"text/css\">.c{vnd.ms-excel.numberformat:@;}</style><table>",'utf-8','gbk');
	if(!isNull($title)){
		echo myIconv("<tr><td colspan=\"{$columnCount}\">".$title."</td></tr>",'utf-8','gbk');
	}
	echo myIconv("<tr>",'utf-8','gbk');
	for($i=0; $i<$columnCount; $i++)
	{
		$meta=$query->result->getColumnMeta($i);
		echo "<td>".myIconv($meta['name'],"utf-8","gbk")."</td>";
	}
	echo myIconv("</tr>",'utf-8','gbk');
	$area=readCache('area.php');
	
	foreach($query->row as $key=>$v)
	{
		$record="<tr>";
		foreach($v as $vKey=>$value)
		{
			$temp=false;
            $fieldValue=str_replace("\r\n","",$value);
			if($vKey=='学校' && is_numeric($fieldValue)){
				$temp=sys::getSchool($schoolList,$fieldValue,true);
			}else if($vKey=='部门' && is_numeric($fieldValue)){
				$temp=sys::getUnit($adminUnit,$fieldValue,true);
			}else if($vKey=='职位' && is_numeric($fieldValue)){
				$temp=sys::getPosition($positionList,$fieldValue,true);
			}else if($vKey=='国家' && is_numeric($fieldValue)){
				$temp=$countryObj->getCountry($fieldValue);
			}else if(($vKey=='籍贯' || $vKey=='户口') && is_numeric($fieldValue)){
				$temp=getAreaLevel($area,$fieldValue," ");
			}else if($vKey=='居住地'){
				$temp=getAreaLevel($area,$fieldValue," ");
			}else if($vKey=='招生人数'){
				$temp=(int)($fieldValue)==0?"0":$fieldValue;
			}
			$fieldValue=$temp==false?$fieldValue:$temp;
			if(isNull($fieldValue)){
				$record.="<td>NULL</td>";
			}else if(is_numeric($fieldValue)){
				$record.="<td class=\"c\">{$fieldValue}</td>";
			}else{
				$record.="<td class=\"c\">{$fieldValue}</td>";
			}
		}
		$record=str_replace('$',"",$record)."</tr>";
		echo myIconv($record,"utf-8","gbk");
	}
	echo myIconv("</table>",'utf-8','gbk');
}


//显示验证码,trLabel表示是否产生两列表格单元格，codeId传递为验证码设置的自定义ID值，不传递时，默认为code，要注意自定义ID时，用于提示信息的SPAN的ID的AJAX操作的ID都有变化，它们的ID将变为"ts_"与你自定义的ID的连接字符串。
function showCode($trLabel=false,$codeId='code')
{
	global $td_config;
    $codeId=isNull($codeId)?'code':$codeId;
    $ts_codeId=$codeId=='code'?'tsCode':'ts_'.$codeId;
	$code=$trLabel?"<tr><td align=\"right\">验证码：</td><td align=\"left\">":"验证码：";
	$code.=<<<html
    <input type="text" name="code" id="{$codeId}" size="4" maxlength="4" class="text" style="ime-mode:disabled;" onblur="td_ajaxRequest('userCheckCode','',this.value,'{$td_config['webPath']}/fastoperation.php','post','html',true,'{$ts_codeId}',0,false,'',false,0)">{$td_config['redStar']}&nbsp;<span id="{$ts_codeId}"></span>&nbsp;<img src="{$td_config['codePath']}/code.inc.php" id="codeImg" onclick="codeRefresh();" style="cursor:pointer;" align="absmiddle" />
html;
	$code.=$trLabel?"</td></tr>":"";
	return $code;
}

//验证码验证
function checkCode()
{
	global $zz_code,$code;
	if((isNull($code) || strcasecmp($code,$_SESSION["code"])!=0))
	{
		$_SESSION["code"]=mt_rand(1000000,9999999);
		$code=NULL;
		return false;
	}
	else
	{
		$_SESSION["code"]=mt_rand(1000000,9999999);
		$code=NULL;
		return true;
	}
}


//产生随机KEY
function submitKey($len=16)
{
    $submitKey="";
    $len=(!is_numeric($len) || (int)($len)<8 || (int)($len)>24)?16:$len;
    while(true)
    {
      $temp=mt_rand(48,122);
      if(($temp>57 && $temp<65) || ($temp>90 && $temp<97))
      {
        continue;
      }
      $submitKey.=chr($temp);
      if(strlen($submitKey)>=$len)
      {
        break;
      }
    }
    $_SESSION["submitKey"]=$submitKey;
    return $submitKey;
}

//产生随机的文件名
function fileName($len=8)
{
    $fileName=time();
    $len=(!is_numeric($len) || (int)($len)<8 || (int)($len)>24)?8:$len;
    $i=0;
    while($i<$len)
    {
        $ch_1=mt_rand(48,57);
        $ch_2=mt_rand(97,122);
        $temp=mt_rand(1,10);
        $fileName.=$temp%2==0?chr($ch_1):chr($ch_2);
        $i++;
    }
    return $fileName;
}
/*
	上传图片，fileType为空表示是图片文件，其它值为对应的文件，比如swf为FLASH文件；$path是文件要上传到的目录，此目录使用相对根目录的地址形式，最后一级的后面不要加"/"，比如：/photo/ads，注意此路径必须是已经存在的路径。
	图片将上传到指定路径后的两级目录中，此两级目录分别是：第一级目录以当前上传文件时的年为命名的文件夹，第二级目录以上传文件时的月和日为命名的文件夹，比如，2012-06-01日期上传的文件，指定的文件夹是"/photo/ads"，则此时，文件真正上传到的目录是"/photo/ads/2012/06-01/fileName.jpg"，此时返回的文件名应该是从年开始的路径地址，如/2012/06-01/fileName.jpg
	注意，如果图片上传成功，此函数返回包含图片名称的一维数组，上传失败返回false
	如果你的file控件的名字是以名字加中括号（exp:photo[]）的形式，则只传递名字部分，不要带有中括号。
*/
function uploadImage($inputName,$fileType="",$path="")
{
  global $td_config,$_FILES;
  $backupPath=$path;
  $image=array();
  
  $path="/".trim($path,"/");//去掉指定文件夹中开始和结束字符"/"，并在开头连接上字符"/"，此操作的目的是保证给出的路径一定是以"/"开头，且不以"/"结尾。
  $path=isNull(trim($path,"/"))?$td_config['webRoot']."/".trim($td_config['imagePath'],"/"):$td_config['webRoot'].$path;//得到从根目录开始到指定目录的路径地址，比如：d:/website/cms/photo
  //指定的路径不存在，或在未指定路径的情况下，系统配置的路径不存在，则不上传文件，且返回false
  if(!file_exists($path))
  {
  	return false;
  }
  
  $autoPath="/".date("Y")."/".date("m-d");//得到真实的存储路径，即年和月日，比如：/2012/06-01
  $path=$path.$autoPath;//得到真实的存储路径，即加上年和月日后的路径，比如：d:/website/cms/photo/2012/06-01
  $fileName=fileName();//生成重命名后的文件名，此时还没有赋值扩展名
  
  //判断$path路径是否存在，如果不存在，则尝试创建
  if(!file_exists($path))
  {
  	//逐级创建不存在的文件夹
    $filePathArray=explode("/",trim($autoPath,"/"));
    $tempPath=isNull($backupPath)?$td_config['webRoot']."/".trim($td_config['imagePath'],"/"):$td_config['webRoot'].$backupPath;//得到从根目录开始到指定目录的路径地址，比如：d:/website/cms/photo
    foreach($filePathArray as $f)
    {
		$tempPath.=($f!="." && $f!=".." && preg_match("/^[a-zA-Z0-9\-]{1,}$/",$f))?("/".$f):"";
		if($f!="." && $f!=".." && preg_match("/^[a-zA-Z0-9-]{1,}$/",$f) && !file_exists($tempPath))
		{
			@mkdir($tempPath,0777);
		}
	}
    $tempPath=NULL;
  }
  
  //配置返回值中文件路径，如果指定存储路径，由指定的存储路径为基准，加上"/YYYY/mm-dd"路径的文件名称路径。如果没有指定存储路径，则返回"/YYYY/mm-dd"加文件名称路径
  $autoPath=(isNull($backupPath)?$autoPath:"/".date("Y")."/".date("m-d"))."/";
  
  $inputName=th($inputName);
  $file=$_FILES[$inputName];
  $trueType=explode(",",$td_config['imageList']);//得到允许上传的文件类型列表，并分解成数组
  
  if(count($file)!=count($file,1))//如果是多维数组，就执行多图片上传
  {
	  for($i=0; $i<count($file["tmp_name"]); $i++)
      {
  		  $fileName=fileName();
          if($file["error"][$i]>0)
          {
              continue;
          }
          if(is_array($trueType))
          {
            $upType=strtolower(mb_substr($file['name'][$i],mb_strlen($file['name'][$i],$td_config['charset'])-3,3,$td_config['charset']));
			if(in_array($upType,$trueType)){
				$fileName.=".{$upType}";
				if(floor($file["size"][$i]/1024)>$td_config['imageSize'])
				{
					continue;
				}else if(move_uploaded_file($file["tmp_name"][$i],"{$path}/{$fileName}")){
					$image[]=$autoPath.$fileName;
				}else{
					continue;
				}
			}else{
				continue;
			}
          }
          else if(strcasecmp($fileType,"swf")==0)
          {
              if(!is_numeric(stripos($file["type"],"flash")))
              {
                  continue;
              }
              if(floor($file["size"][$i]/1024)>$td_config['imageSize'])
              {
                  continue;
              }
              $fileName=$fileName.".swf";
              if(move_uploaded_file($file["tmp_name"],"{$path}/{$fileName}"))
              {
                  $image[]=$autoPath.$fileName;
              }
          }
      }
      if(count($image)==0)
      {
       	return false;
      }
      else
      {
      	return $image;
      }
  }
  else
  {
      if($file["error"]>0)
      {
          return false;
      }
      if(isNull($fileType) && is_array($trueType))
      {
		$upType=strtolower(mb_substr($file['name'],mb_strlen($file['name'],$td_config['charset'])-3,3,$td_config['charset']));
        $exit=0;
		if(in_array($upType,$trueType)){
			$fileName.=".{$upType}";
			if(floor($file["size"]/1024)>$td_config['imageSize'])
			{
				return false;
			}
			if(move_uploaded_file($file["tmp_name"],"{$path}/{$fileName}"))
			{
				$image[]=$autoPath.$fileName;
				return $image;
			}
			else
			{
				return false;
			}
		}else{
            return false;
        }
      }
      else if(strcasecmp($fileType,"swf")==0)
      {
          if(!is_numeric(stripos($file["type"],"flash")))
          {
              return false;
          }
          if(floor($file["size"]/1024)>$td_config['imageSize'])
          {
              return false;
          }
          $fileName=$fileName.".swf";
          if(move_uploaded_file($file["tmp_name"],"{$path}/{$fileName}"))
          {
          	  $image[]=$autoPath.$fileName;
              return $image;
          }
          else
          {
              return false;
          }
      }
      else
      {
          return false;
      }
  }
}

//图片加水印，此函数无返回值，图片以原文件名保存到原有的路径中
function imageWaterMark($groundImage,$waterPos=0,$waterImage="",$waterText="",$fontSize=16,$textColor="#FF0000") 
{ 
    $isWaterImage = FALSE; 
    $formatMsg = "暂不支持该文件格式，请用图片处理软件将图片转换为GIF、JPG、PNG格式。";
    $fontFile="./STCAIYUN.TTF";//如果是文字水印，则由此指出文字的字体

    //读取水印文件 
    if(!empty($waterImage) && file_exists($waterImage)) 
    { 
        $isWaterImage = TRUE; 
        $water_info = getimagesize($waterImage); 
        $water_w    = $water_info[0];//取得水印图片的宽 
        $water_h    = $water_info[1];//取得水印图片的高 

        switch($water_info[2])//取得水印图片的格式 
        { 
            case 1:$water_im = imagecreatefromgif($waterImage);break; 
            case 2:$water_im = imagecreatefromjpeg($waterImage);break; 
            case 3:$water_im = imagecreatefrompng($waterImage);break; 
            default:
            	return false; 
        } 
    } 

    //读取背景图片 
    if(!empty($groundImage) && file_exists($groundImage)) 
    { 
        $ground_info = getimagesize($groundImage); 
        $ground_w    = $ground_info[0];//取得背景图片的宽 
        $ground_h    = $ground_info[1];//取得背景图片的高 

        switch($ground_info[2])//取得背景图片的格式 
        { 
            case 1:$ground_im = imagecreatefromgif($groundImage);break; 
            case 2:$ground_im = imagecreatefromjpeg($groundImage);break; 
            case 3:$ground_im = imagecreatefrompng($groundImage);break; 
            default:
            	return false;
        } 
    } 
    else 
    { 
        return false;
    } 

    //水印位置 
    if($isWaterImage)//图片水印 
    { 
        $w = $water_w; 
        $h = $water_h; 
        $label = "图片的"; 
    } 
    else//文字水印 
    { 
        $temp = imagettfbbox(ceil($fontSize),0,$fontFile,$waterText);//取得使用 TrueType 字体的文本的范围，./Fzstfw.ttf是字体文件的相对路径
        $w = $temp[2] - $temp[6]; 
        $h = $temp[3] - $temp[7]+15; 
        unset($temp); 
        $label = "文字区域"; 
    } 
    if( ($ground_w<$w) || ($ground_h<$h) ) 
    { 
        return false; 
    } 
    switch($waterPos) 
    { 
        case 0://随机 
            $posX = rand(0,($ground_w - $w)); 
            $posY = rand(0,($ground_h - $h)); 
            break; 
        case 1://1为顶端居左 
            $posX = 0; 
            $posY = 0; 
            break; 
        case 2://2为顶端居中 
            $posX = ($ground_w - $w) / 2; 
            $posY = 0; 
            break; 
        case 3://3为顶端居右 
            $posX = $ground_w - $w; 
            $posY = 0; 
            break; 
        case 4://4为中部居左 
            $posX = 0; 
            $posY = ($ground_h - $h) / 2; 
            break; 
        case 5://5为中部居中 
            $posX = ($ground_w - $w) / 2; 
            $posY = ($ground_h - $h) / 2; 
            break; 
        case 6://6为中部居右 
            $posX = $ground_w - $w; 
            $posY = ($ground_h - $h) / 2; 
            break; 
        case 7://7为底端居左 
            $posX = 0; 
            $posY = $ground_h - $h; 
            break; 
        case 8://8为底端居中 
            $posX = ($ground_w - $w) / 2; 
            $posY = $ground_h - $h; 
            break; 
        case 9://9为底端居右 
            $posX = $ground_w - $w; 
            $posY = $ground_h - $h; 
            break; 
        default://随机 
            $posX = rand(0,($ground_w - $w)); 
            $posY = rand(0,($ground_h - $h)); 
            break;     
    } 

    //设定图像的混色模式 
    imagealphablending($ground_im, true); 

    if($isWaterImage)//加图片水印 
    { 
        imagecopy($ground_im, $water_im, $posX, $posY, 0, 0, $water_w,$water_h);//拷贝水印到目标文件         
    } 
    else//加文字水印 
    { 
        if( !empty($textColor) && (strlen($textColor)==7) ) 
        { 
            $R = hexdec(substr($textColor,1,2)); 
            $G = hexdec(substr($textColor,3,2)); 
            $B = hexdec(substr($textColor,5)); 
        } 
        else 
        { 
            return false;
        } 
        imagettftext($ground_im,$fontSize,0,$posX,$posY,imagecolorallocate($ground_im, $R, $G, $B),$fontFile,$waterText);
    } 

    //生成水印后的图片 

    @unlink($groundImage); 
    switch($ground_info[2])//取得背景图片的格式 
    { 
        case 1:imagegif($ground_im,$groundImage);break; 
        case 2:imagejpeg($ground_im,$groundImage);break; 
        case 3:imagepng($ground_im,$groundImage);break; 
        default:
        	return false;
    } 

    //释放内存 
    if(isset($water_info)) unset($water_info); 
    if(isset($water_im)) imagedestroy($water_im); 
    unset($ground_info); 
    imagedestroy($ground_im); 
} 




//定义FLASH播放器
function flashPlayer($fileName="",$company="",$width=200,$height=150)
{
    $flashId="a".fileName();//产生该FLASH模块的ID值
    $fileName=th($fileName);
    $company=th($company);
    $flash=<<<html
    <object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="{$width}" height="{$height}" id="{$flashId}" title="{$company}">
  <param name="movie" value="{$fileName}" />
  <param name="quality" value="high" />
  <param name="wmode" value="opaque" />
  <param name="loop" value="true" />
  <param name="scale" value="Exactfit" />
  <param name="swfversion" value="6.0.65.0" />
  <!-- 此 param 标签提示使用 Flash Player 6.0 r65 和更高版本的用户下载最新版本的 Flash Player。如果您不想让用户看到该提示，请将其删除。 -->
  <param name="expressinstall" value="/swfincfile/expressInstall.swf" />
  <!-- 下一个对象标签用于非 IE 浏览器。所以使用 IECC 将其从 IE 隐藏。 -->
  <!--[if !IE]>-->
  <object type="application/x-shockwave-flash" data="{$fileName}" width="{$width}" height="{$height}">
    <!--<![endif]-->
    <param name="quality" value="high" />
    <param name="wmode" value="opaque" />
    <param name="swfversion" value="6.0.65.0" />
    <param name="expressinstall" value="/swfincfile/expressInstall.swf" />
    <!-- 浏览器将以下替代内容显示给使用 Flash Player 6.0 和更低版本的用户。 -->
    <div>
      <h4>此页面上的内容需要较新版本的 Adobe Flash Player。请点击下载</h4>
      <p><a href="http://www.adobe.com/go/getflashplayer"><img src="http://www.adobe.com/images/shared/download_buttons/get_flash_player.gif" alt="下载 Adobe Flash Player到本地" width="112" height="33" /></a></p>
    </div>
    <!--[if !IE]>-->
  </object>
  <!--<![endif]-->
</object>
html;
    return $flash;
}
//设置图片的URL，$url一般情况只需要传递文件名称即可；$headImg表示要查找的是否是用户的头像路径，默认false不是。
function imgUrl($url,$headImg=false)
{
	global $td_config;
    $url=trim($url,"/");
	if(isNull($url) && $headImg==false)
    {
    	return "{$td_config['webPath']}/images/nopic60.gif";
    }
    else if(isNull($url) && $headImg)
    {
    	return "{$td_config['webPath']}{$td_config['headerImage']}/noheadimg.png";
    }
    else if($headImg==false)
    {
    	if(file_exists("{$td_config['webRoot']}{$td_config['imagePath']}/{$url}"))
        {
        	return "{$td_config['webPath']}{$td_config['imagePath']}/{$url}";
        }
    	else
        {
        	return "{$td_config['webPath']}/images/nopic60.gif";
        }
    }
    else
    {
    	if(file_exists("{$td_config['webRoot']}{$td_config['headerImage']}/{$url}"))
        {
        	return "{$td_config['webPath']}{$td_config['headerImage']}/{$url}";
        }
    	else
        {
        	return "{$td_config['webPath']}{$td_config['headerImage']}/noheadimg.png";
        }
    }
}

//获取服务器上指定文件的MIME类型，文件必须使用服务器的绝对路径，函数返回一维数组
//获取成功，返回类似如下数组：Array ( [0] => 201201070919251325899165bpiw08j6 [1] => application/octet-stream )
//第一个元素是文件名称，第二个元素是文件的MIME类型
function mime($file)
{
	global $td_config;
    $mime=array();
	if(!file_exists($file))
    {
    	return $mime;
    }
    $fileInfo=pathinfo($file);
    $mime[]=$fileInfo["filename"];
    foreach($td_downloadType as $key=>$t)
    {
    	if(strtolower($key)==strtolower($fileInfo["extension"]))
        {
        	$mime[]=$t;
            break;
        }
    }
    return $mime;
}

//资料下载，table是需要下载文件所在的数据表名称，id是记录的ID值，path是下载文件所在的绝对路径
function download($table,$id,$v,$path="")
{
	global $query,$td_config,$td_msg;
	if(isNull($table) || !is_numeric($id) || isNull($v))
    {
    	return $td_msg[0];
    }
    if(!$td_userDownload && isNull($td_config['userNick']))
    {
    	return $td_msg[8];
    }
    $row=query("select * from {$td_config['pre']}{$table} where id={$id}",false);
    if(is_array($row) && count($row)>0)
    {
    	extract($row);
    	$path="{$td_config['webRoot']}{$td_config['downloadPath']}/{$fileName}";
        $mime=mime($path);
        header('Pragma: public');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Cache-Control: private',false);
        header('Content-Type: '.$mime[1]);
        header('Content-Disposition: attachment; filename="'.basename($fileName).'"');
        header('Content-Transfer-Encoding: binary');
        header('Connection: close');
        readfile($path);
        myupdate("update {$td_config['pre']}{$table} set downloads=downloads+1 where id={$id}");
		return 0;
    }
    else
    {
    	return 2;
    }
}

//读取sql缓存,参数是sql语句的MD5值
function readSqlCache($file)
{
	global $td_config;
    $folder=$file{4}.$file{5};
    $file="{$td_config['webRoot']}{$td_config['cachePath']}/sql/{$folder}/{$file}.php";
	if(file_exists($file))
    {
    	return require($file);
    }
    else
    {
    	return array();
    }
}

/*
包含带标签的模板，label_template参数传递模板文件，自模板文件夹开始的路径及模板名称，如："/sell/list.htm"将被自动识别成"/template/sell/list.htm"。loginRead表明是否验证登录状态，如验证，则只有处于登录状态的用户再能打开；readControl表明是否验证此会员所在的组是否有查看权限；如果category参数，则在检测栏目的阅读权限时，只检测此指定的栏目列表，不指定时，则对所有的栏目检测。$admin给出引用的模板是否是后台管理模板，默认不是。后台管理模板，统一放在模板文件夹根目录的admin目录下，给出模板路径时，只给出从admin目录开始目录即可（不要加/admin/目录），例如："/sell/list.htm"后台模板，则自动识别为"/template/admin/sell/list.htm"。
注意：要进行阅读权限控制，必须满足以下条件
1、当前页设置了$moduleId(当前模块的ID）和$module（当前模块的数据数组）变量，无此二个变量，则模块控制无效
2、当前页设置了catId（当前栏目的ID值），无此变量则栏目控制无效
除输出标签外，其它标签内使用的语句语法均与PHP一致，当然输出语句你也可以使用PHP的，但你不能使用{php= 输出内容/php}这种格式了。
模板中语法格式：
	<!--php PHP代码 -->
    {php= 需要输出的内容 /php}　　数据输出标签
*/
function td_require($label_template,$admin=false)
{
	extract($GLOBALS);
	$moduleId=isset($moduleId)?$moduleId:'';
	if($td_config['webUrl']!='/index.php' && $td_config['webUrl']!='/index.html' && (!isset($_SESSION['userNick']) || isNull($_SESSION['userNick']))){
		exit("请登录后访问");
	}
    //解析模板中的标签，并将生成的PHP代码保存到/file文件夹中对应的模块文件夹中，没有指定模块时，保存到/file目录的根目录中
    if($admin)//生成后台管理模板的模板路径
    {
    	$label_template=substr($label_template,0,1)!="/"?"/admin/{$label_template}":"/admin".$label_template;
    }
    else
    {
    	$label_template=substr($label_template,0,1)!="/"?"/{$label_template}":$label_template;
    }
    $label_templateFile="{$td_config['webRoot']}{$td_config['templatePath']}{$label_template}";
    if(!file_exists($label_templateFile))
    {
    	return false;
    }
    //extract($GLOBALS,EXTR_SKIP);
    if($td_config['templateCache'])
    {
    	$label_cacheFolder=module::getModulePath($moduleList,$moduleId);
        if($label_cacheFolder==false)
        {
            $label_cacheFolder="{$td_config['webRoot']}/file";
        }
        else
        {
            $label_cacheFolder=str_replace("\\","/","{$td_config['webRoot']}/file/{$label_cacheFolder}");
            if(!file_exists($label_cacheFolder))
            {
            	//逐级创建不存在的文件夹
            	$filePathArray=explode("/",trim(str_replace($td_config['webRoot']."/file","",$label_cacheFolder),"/"));
                $filePath=$td_config['webRoot']."/file";
                foreach($filePathArray as $f)
                {
                    $filePath.=($f!="." && $f!=".." && preg_match("/^[a-zA-Z0-9\-]{1,}$/",$f))?("/".$f):"";
                    if($f!="." && $f!=".." && preg_match("/^[a-zA-Z0-9-]{1,}$/",$f) && !file_exists($filePath))
                    {
                        @mkdir($filePath,0777);
                    }
                }
            }
        }
        $label_cacheFolder=str_replace('//','/',$label_cacheFolder."/".md5($label_template).".php");
        if(!file_exists($label_cacheFolder))
        {
            $label_fileContent=file_get_contents($label_templateFile);
            $label_fileContent=str_replace(array("<!--php","/php-->"),array("<?php\r\n","\r\n?>"),$label_fileContent);
            $label_fileContent=preg_replace('/(\{php=[\s]*)/','<?php echo ',$label_fileContent);
            $label_fileContent=preg_replace('/([\s]*[\;]*[\s]*\/php\})/',';?>',$label_fileContent);
            $label_fileContent="<?php\r\n defined(\"td_erp\") or exit(\"Access Denied\");\r\n ?>\r\n".$label_fileContent;
            $fp=fopen($label_cacheFolder,"w+");
            fwrite($fp,$label_fileContent);
            fclose($fp);
        }
    }
    else
    {
    	$label_cacheFolder=$label_templateFile;
    }
    require($label_cacheFolder);
    return true;
}


//读取缓存
function readCache($file)
{
	global $td_config,$webRoot,$td_cachePath,$_groupId;
	$file="{$td_config['webRoot']}{$td_config['cachePath']}/{$file}";
	$result=array();
	if(file_exists($file))
	{
		$result=require($file);
		if(isset($result[0]) && isNull($result[0])){
			unset($result[0]);
		}
        return $result;
	}
    else
    {
        return array();
    }
}

//解析字符串形式的JSON数据到数组
function jsonToArray($v="")
{
	if(isNull($v))
    {
    	return false;
    }
	if(is_array($v)){
		return $v;
	}
	$v=stripslashes($v);
	$v=trim($v,"{");
	$v=trim($v,"}");
	$json=explode(",",$v);
    $arr=array();
    foreach($json as $key=>$j)
    {
		$v=explode(":",$j);
		$v[0]=trim($v[0],"'");
		$v[1]=trim($v[1],"'");
		$v[0]=trim($v[0],'"');
		$v[1]=trim($v[1],'"');
		$arr[$v[0]]=$v[1];
    }
    return $arr;
}

//生成数量单位SELECT
function unitsSelect($name='',$id='',$js='',$checkedId=''){
	$name=!preg_match("/[a-z]{1,20}/i",$name)?'units':$name;
	$id=!preg_match("/[a-z]{1,20}/i",$id)?'units':$id;
	$temp=array('个','双','对','套','辆','张','盒','条','只','台','桶','市斤','斤','公斤','组','件','把','捆','克','千克','米','千米','公尺','平方毫米','平方分米','平方米','其它');
	$select=<<<html
		<select name="{$name}" id="{$id}" onChange="{$js}">
html;
	foreach($temp as $t){
		$selected=$checkedId==$t?" selected":'';
		$select.=<<<html
		<option value="{$t}" {$selected}>{$t}</option>
html;
	}
	return $select.'</select>';
}


/*
此函数的作用是包含一个可共用的列表页中列表项的碎片文件，被包含的文件不支持模板语法。
$debrisFile指定模板文件夹中debris文件夹中的某个被包含文件的全名（exp:news_list.htm），此文件只能是php、htm或html文件中的一种格式。
$tags以引用（按地址传递）方式接收需要列表显示的内容数组，一般包含如下元素：id,title,inTime或editTime,catId,linkUrl。
$param定义配置数组，数组包含元素如下array("catName"=>true/false是否列表所在栏目的名称,"date"=>"m-d"如果需要列出日期给出日期格式,"titleLen"=>20标题的截取长度；不需要截取可不填写)，此数组中的元素，如果不需要此项配置，可不包含此元素。另外，还可根据被包含文件中的配置参数设置来自定义添加其它数组元素。
*/
function tags($debrisFile,&$tags,$param)
{
	global $td_config;
	if(isNull($debrisFile))
    {
    	return false;
    }
    if(!in_array(mb_substr(strtolower($debrisFile),mb_strlen($debrisFile,"utf-8")-3,3,"utf-8"),array("php","htm","tml")))
    {
    	return false;
    }
    if(!file_exists($td_config['webRoot'].$td_config['templatePath']."/debris/".$debrisFile))
    {
    	return false;
    }
	require($td_config['webRoot'].$td_config['templatePath']."/debris/".$debrisFile);
}

//删除文件夹中的文件和文件夹,file_path给出被删除文件的绝对路径，此函数只能删除CACHE和FILE文件夹中的文件
function delete_file($file_path)
{
	global $td_config;
    if(isNull($td_config['userNick']))
    {
    	echo"文件操作失败，你的权限不够";
    	return false;
    }
    $str_1=mb_substr($file_path,0,mb_strlen("{$td_config['webRoot']}/file",$td_charset),$td_charset);
    $str_2=mb_substr($file_path,0,mb_strlen("{$td_config['webRoot']}/cache",$td_charset),$td_charset);
    if(strcasecmp($str_1,"{$td_config['webRoot']}/file")!=0 && strcasecmp($str_2,"{$td_config['webRoot']}/cache")!=0)
    {
    	echo"文件操作失败，无权操作此文件或文件夹";
    	return false;
    }
	if(is_dir($file_path))
	{
		$dir=opendir($file_path);
		while($fileName=readdir($dir))
		{
			if($fileName=="." || $fileName==".." || $fileName=="jobconfig.inc.php")
			{
				continue;
			}
			$temp="{$file_path}/{$fileName}";
			if(is_dir($temp))
			{
				delete_file($temp);
				@chmod($temp,0777);
				@unlink($temp);
			}
			else
			{
				@chmod($temp,0777);
				@unlink($temp);
			}
		}
		closedir($dir);
        if($file_path!="{$td_config['webRoot']}/cache/" && $file_path!="{$td_config['webRoot']}/cache" && $file_path!="{$td_config['webRoot']}/file/" && $file_path!="{$td_config['webRoot']}/file")//保留file和cache文件夹
        {
			@chmod($file_path,0777);
			@rmdir($file_path);
        }
	}
	else
	{
		@chmod($file_path,0777);
		@unlink($file_path);
	}
	return true;
}
/*
	配置COOKIE操作，此函数可用于定义COOKIE，或取指定COOKIE的值，当$value为空时为取值操作；COOKIE的名称只能以字母或下划线开头，可字母、下划线和数字组成，最长不超过12个字符。
	此COOKIE操作函数可一次操作多个COOKIE，COOKIE名称以一维数组的形式传递；且对应的值也要以一维数组的形式传递，且一一对应。
	取值操作时，如果指定的COOKIE名称是多个，则$value不需要传递一维数组，只需要将$value的值传递为空或空字符即可。
	如果是取值操作，返回包含值的一维数组；当为定义COOKIE操作时，返回空的一维数组
*/
function cookie($name="",$value="",$outTime="",$path="/",$url="")
{
	$result=array();
    $outTime=(isNull($outTime) || !is_numeric($outTime))?time()+3600:(int)($outTime);
	if(is_array($name))
	{
		foreach($name as $key=>$n)
		{
			if(!is_array($value))
			{
				$v=$value;
			}
			else if(count($name)!=count($value))
			{
				$v=$value[0];
			}
			else
			{
				$v=$value[$key];
			}
			if(!preg_match("/^[a-zA-Z_]{1}[a-zA-Z0-9_]{0,11}$/",$n))
			{
				return false;
			}
			if(!isNull($v))
			{
				setcookie($n,$v,$outTime,$path,$url);
			}
			else
			{
				if(isset($_COOKIE[$n]))
				{
					$result[]=rawurldecode($_COOKIE[$n]);
				}
			}
		}
	}
	else
	{
		if(!preg_match("/^[a-zA-Z_]{1}[a-zA-Z0-9_]{0,11}$/",$name))
		{
			return false;
		}
		if(!isNull($value))
		{
			setcookie($name,$value,$outTime,$path,$url);
		}
		else
		{
			if(isset($_COOKIE[$name]))
			{
				$result[]=rawurldecode($_COOKIE[$name]);
			}
		}
	}
	return $result;
}

//格式化数字，不足位补字符，$x传递要补足位的数值，$length传递数字的最大字符数，默认5位，$ch传递不足位时数字前面要补的字符
function format_number($x=0,$length=5,$ch='0'){
	global $td_config;
	$length=(!is_numeric($length) || (int)($length)<1)?5:(int)($length);
	$ch=isNull($ch)?'0':"{$ch}";
	if(isNull($x)){
		return $x;
	}else{
		$x="{$x}";
	}
	$len=mb_strlen($x,$td_config['charset']);
	if($len<$length){
		for($i=0; $i<$length-$len; $i++){
			$x=$ch.$x;
		}
	}
	return $x;
}

//输出年SELECT
function yearSelect($name="",$id="",$js="",$checked=""){
	global $td_config;
	$name=preg_match("/^[a-z]{1}[a-z0-9_]{2,11}$/",$name)?$name:"yearId";
	$id=preg_match("/^[a-z]{1}[a-z0-9_]{2,11}$/",$id)?$id:"yearId";
	$js=isNull($js)?"":" onchange=\"{$js}\"";
	$select="<select name=\"{$name}\" id=\"{$id}\" {$js}><option value=\"-1\">---请选择---</option>";
	for($i=2014; $i<=date("Y"); $i++){
		$selected=$i==$checked?" selected":'';
		$select.=<<<html
		<option value="{$i}" {$selected}>{$i}</option>
html;
	}
	return $select."</select>";
}
//输出月SELECT
function monthSelect($name="",$id="",$js="",$checked=""){
	global $td_config;
	$name=preg_match("/^[a-z]{1}[a-z0-9_]{2,11}$/",$name)?$name:"monthId";
	$id=preg_match("/^[a-z]{1}[a-z0-9_]{2,11}$/",$id)?$id:"monthId";
	$js=isNull($js)?"":" onchange=\"{$js}\"";
	$select="<select name=\"{$name}\" id=\"{$id}\" {$js}><option value=\"-1\">---请选择---</option>";
	for($i=1; $i<=12; $i++){
		$selected=$i==$checked?" selected":'';
		$v=format_number($i,2,"0");
		$select.=<<<html
		<option value="{$v}" {$selected}>{$v}</option>
html;
	}
	return $select."</select>";
}

/*
	给出一个字符串，获取每一个字符的拼音声母
*/
function getPY($str=''){
	global $td_config;
	if(isNull($str)){
		return false;
	}
	$word=mb_substr($str,0,1,$td_config['charset']);
	$pyList=file("{$td_config['webRoot']}{$td_config['incPath']}/wordpinyin.txt");
	foreach($pyList as $p){
		$v=explode(' ',$p);
		if($v[0]==$word){
			return strtoupper(mb_substr($v[1],0,1,$td_config['charset']));
		}
	}
	return false;
}

//获取资产状态信息
function getAssetStatus($id=0){
	if(!is_numeric($id)){
		return false;
	}
	$temp=array('待审','正常','借出','维修','报废');
	foreach($temp as $key=>$t){
		if($id==$key){
			return $t;
		}
	}
	return false;
}
//输出资产状态SELECT
function assetStatusSelect($name='',$id='',$js='',$checkedId=0){
	$name=!preg_match("/[a-z]{1,20}/i",$name)?"status":$name;
	$id=!preg_match("/[a-z]{1,20}/i",$id)?"status":$id;
	$onchange=isNull($js)?'':" onChange=\"{$js}\"";
	$checkedId=is_numeric($checkedId)?$checkedId:'-1';
	$temp=array('待审','正常','借出','维修','报废');
	$select=<<<html
	<select name="{$name}" id="{$id}" {$onchange}><option value="-1">全部</option>
html;
	foreach($temp as $key=>$t){
		$selected=$checkedId==$key?" selected":'';
		$select.=<<<html
		<option value="{$key}" {$selected}>{$t}</option>
html;
	}
	return $select."</select>";
}
//输出资产分类名称或编号ID，给出名称输出编号ID，给出编号ID输出名称，未找到时将给出的编号或名称原样输出
function getAssetType($typeName='',$typeNo=''){
	global $td_config;
	if(isNull($typeName) && isNull($typeNo)){
		return false;
	}
	if(!isNull($typeName)){
		$row=getone("select id from {$td_config['pre']}assettype where typeName='{$typeName}'",true);
	}else{
		$row=getone("select typeName from {$td_config['pre']}assettype where id='{$typeNo}'",true);
	}
	if(is_array($row)){
		return !isNull($typeName)?$row['id']:$row['typeName'];
	}
	return !isNull($typeName)?$typeName:$id;
}

//操作日志
function journalIn($msg=''){
	global $td_online,$td_config;
	if(isNull($msg)){
		return false;
	}
	$msg=mb_substr($msg,0,255,$td_config['charset']);
	myupdate("insert into {$td_config['pre']}journal(userNick,memo,inTime,ip) values('{$td_online['userNick']}','{$msg}','{$td_config['dateTime']}','{$td_config['ip']}')");
	return mysql_errno()?false:true;
}

//上一级窗口转向到指定地址
function parentUrlGo($url="",$msg="")
{
	$msg=addslashes($msg);
	$msg=isNull($msg)?"":"alert('{$msg}');";
    $url=isNull($url)?"parent.document.location.reload();":"parent.document.location='{$url}';";
	echo '<script type="text/javascript">';
	echo<<<html
      {$msg}
      {$url}
html;
	echo'</script>';
}
?>