<?php
!defined("td_erp")?exit("Access Denied"):'';
class module{
	//获取指定的模块，$moduleList接收模块二维数组,$id接收指定模块的ID，$onlyName指定是否只返回模块的名称
	static function getModule(&$moduleList,$id=0,$onlyName=false){
		if(!is_array($moduleList)){
			return false;
		}
		if(!is_numeric($id) || $id<1){
			if($onlyName){
				$result=array();
				foreach($moduleList as $m){
					$result[]=$m['moduleName'];
				}
				return $result;
			}else{
				return $moduleList;
			}
		}else{
			$id=(int)($id);
			foreach($moduleList as $m){
				if($m['id']==$id){
					return $onlyName?$m['moduleName']:$m;
				}
			}
			return false;
		}
	}
	//获取指定模块所在的文件夹
	static function getModulePath(&$moduleList,$id){
		if(!is_array($moduleList) || !is_numeric($id)){
			return false;
		}
		foreach($moduleList as $m){
			if($m['id']==$id){
				return $m['path'];
			}
		}
		return false;
	}
	//构造模块SELECT
	static function moduleSelect(&$moduleList,$name='',$id='',$js='',$checkedId=0){
		if(!is_array($moduleList)){
			return false;
		}
		$name=!preg_match("/[a-z]{1,20}/i",$name)?'moduleId':$name;
		$id=!preg_match("/[a-z]{1,20}/i",$id)?'moduleId':$id;
		$onChange=isNull($js)?'':" onChange=\"{$js}\"";
		$checkedId=!is_numeric($checkedId)?0:(int)($checkedId);
		$select=<<<html
		<select name="{$name}" id="{$id}" {$onChange}><option value="-1">---请选择---</option>
html;
		foreach($moduleList as $m){
			$selected=$checkedId==$m['id']?" selected":'';
			$select.="<option value=\"{$m['id']}\" {$selected}>{$m['moduleName']}</option>";
		}
		$select.="</select>";
		return $select;
	}
	
/*
	操作指令相关方法
*/
	
	//获取指定模块可用的权限指令数组
	static function getAdminArray(&$moduleOperate,$id){
		if(!is_array($moduleOperate) || !is_numeric($id)){
			return false;
		}
		foreach($moduleOperate as $m){
			if($m['moduleId']==$id){
				return jsonToArray($m['opArray']);
			}
		}
		return false;
	}
	//给出操作指令列表，得出对应的权限描述
	static function getAdminArrayName($position,$moduleId=0){
		global $moduleOperate;
		$position=trim($position,',');
		if(isNull($position) || !is_numeric($moduleId)){
			return false;
		}
		$opArray=self::getAdminArray($moduleOperate,$moduleId);
		if(!is_array($opArray)){
			return false;
		}
		$position=explode(',',$position);
		$result=array();
		foreach($position as $p){
			$result[]=$opArray[$p];
		}
		return count($result)==0?false:$result;
	}
}
?>