<?php
defined("td_erp") or exit("Access Denied");
function query($sql,$useCache=false)
{
	global $conn;
	$useCache=(is_bool($useCache) && $useCache===true)?true:false;
	$query=new queryClass($conn);
	$query->query($sql,1,$useCache);
	return $query->row;
}

function getone($sql,$useCache=false)
{
	global $conn;
	$useCache=(is_bool($useCache) && $useCache===true)?true:false;
	$query=new queryClass($conn);
	if(!is_numeric(stripos($sql,"limit")))
	{
		$sql.=" limit 0,1";
	}
	$query->query($sql,1,$useCache);
	if($query->recordCount==0)
	{
		return false;
	}
	else
	{
		return $query->row[0];
	}
}

function myupdate($sql)
{
	global $conn;
	$sql=trim($sql);
	try{
		$pdo=$conn->exec($sql);
		if(strtolower(mb_substr($sql,0,6))==="insert")
		{
			$id=$conn->lastInsertId();
			return  is_numeric($id)?$id:0;
		}
		else
		{
			return true;
		}
	}catch (PDOException $e){
		
		die("Error:".$e->getMessage());
	}
}

class queryClass
{
	public $conn;
	public $row=array();
	public $isArrayes;//查询结果是不是多维数组，暂时不用
	public $recordCount;
	public $errno;
	public $sql;
	public $result;
	public $error;
	function __construct($conn="",$row="",$recordCount=0,$errno=0,$sql="",$result="",$error="")
	{
		$this->conn=$conn;
		$this->recordCount=$recordCount;
		$this->errno=$errno;
		$this->sql=$sql;
		$this->result=$result;
		$this->error=0;
	}
	//getRow是否将查询的记录返回，为0时不返回查询的记录结果
	function query($sql="",$getRow=0,$useCache=false)
	{
		global $td_config;
		$getRow=($getRow===false || !is_numeric($getRow) || intval($getRow)==0)?0:1;
		$useCache=(is_bool($useCache) && $useCache===true)?true:false;
		$this->sql=$sql;
		$this->row=NULL;
		$this->row=array();
		if(isNull($this->sql))
		{
			$this->errno=1;//参数错误
			return;
		}
		
		//SQL缓存技术
		$path=$td_config['webRoot'].$td_config['cachePath'];
		$cacheTime=&$td_config['cacheTime'];
		if($useCache && is_numeric($cacheTime) && $cacheTime>0)//使用缓存
		{
			$cacheTime=(integer)($cacheTime);
			$sqlMD5=md5($sql);
			$sqlFolder=$sqlMD5{4}.$sqlMD5{5};
			if(!file_exists($path))
			{
				mkdir($path,0777);
			}
			$path.="/sql";
			if(!file_exists($path))
			{
				mkdir($path,0777);
			}
			$path.="/{$sqlFolder}";
			if(!file_exists($path))
			{
				mkdir($path,0777);
			}
			$path.="/{$sqlMD5}.php";
			
			
			if(file_exists($path))
			{
				if(filemtime($path)+$cacheTime<time())
				{
					//数据查询
					try{
						$this->result=$this->conn->query($this->sql);
						$this->result->setFetchMode(PDO::FETCH_ASSOC);
						$this->row=$this->result->fetchAll();
						$this->recordCount=$this->result->rowCount();
						//写缓存
						@chmod($path,0777);
						$fp=fopen($path,"w+");
						fwrite($fp,"<?php\r\n defined(\"td_erp\") or exit(\"Access Denied\");\r\n return ".var_export($this->row,true).";\r\n?>");
						fclose($fp);
					}catch(PDOException $e){
						die("Error:".$e->getMessage());
					}
				}
			}
			else
			{
				//数据查询
				try{
					$this->result=$this->conn->query($this->sql);
					$this->result->setFetchMode(PDO::FETCH_ASSOC);
					$this->row=$this->result->fetchAll();
					$this->recordCount=$this->result->rowCount();
					//写缓存
					$fp=fopen($path,"w+");
					fwrite($fp,"<?php\r\n defined(\"td_erp\") or exit(\"Access Denied\");\r\n return ".var_export($this->row,true).";\r\n?>");
					fclose($fp);
				}catch(PDOException $e){
					die("Error:".$e->getMessage());
				}
			}
			
			//读缓存
			$this->row=readSqlCache($sqlMD5);
			$this->recordCount=count($this->row);
		}
		else//不使用缓存
		{	
			try{
				//数据查询
				$this->result=$this->conn->query($this->sql);
				$this->result->setFetchMode(PDO::FETCH_ASSOC);
				$this->row=$this->result->fetchAll();
				$this->recordCount=$this->result->rowCount();
			}catch (PDOException $e){
				die("Error:".$e->getMessage());
			}
		}
	}
	function __destruct()
	{
	}
}


  
  
class pageShow
{
	public $page;
	public $sql;
	public $conn;
	public $recordCount;
	public $pageSize;
	public $row=array();
	public $errno;
	public $error;
	public $pageString;
	function __construct($conn="",$sql="",$page="",$pageSize=10)
	{
		$this->conn=$conn;
		$this->sql=$sql;
		$this->page=$page;
		$this->pageSize=$pageSize;
		$this->errno=0;
		$this->error="";
		$this->pageString="";
		$this->recordCount=0;
	}
	private function sqlQuery($sql,$getRow=true)
	{
		$getRow=(is_bool($getRow) && $getRow===true)?true:false;
		$this->row=NULL;
		$this->row=array();
		try{
			$result=$this->conn->query($sql);
			$result->setFetchMode(PDO::FETCH_ASSOC);
			$this->row=$result->fetchAll();
			$this->recordCount=$result->rowCount();
		}catch(PDOException $e){
			die("Error:".$e->getMessage());
		}
	}
	private function cacheSql($sql)
	{
		global $td_config;
		$this->row=NULL;
		$this->row=array();
		$path=$td_config['webRoot']."/cache";
		$cacheTime=$td_config['cacheTime'];
		$cacheTime=(integer)($cacheTime);
		$sqlMD5=md5($sql);
		$sqlFolder=$sqlMD5{4}.$sqlMD5{5};
		if(!file_exists($path))
		{
			mkdir($path,0777);
		}
		$path.="/sql";
		if(!file_exists($path))
		{
			mkdir($path,0777);
		}
		$path.="/{$sqlFolder}";
		if(!file_exists($path))
		{
			mkdir($path,0777);
		}
		$path.="/{$sqlMD5}.php";
		
		//数据缓存
		if(file_exists($path))
		{
			if(filemtime($path)+$cacheTime<time())
			{
				$this->sqlQuery($sql,1);
				@chmod($path,0777);
				$fp=fopen($path,"w+");
				fwrite($fp,"<?php\r\n defined(\"td_erp\") or exit(\"Access Denied\");\r\n return ".var_export($this->row,true).";\r\n?>");
				fclose($fp);
			}
		}
		else
		{
			$this->sqlQuery($sql,1);
			$fp=fopen($path,"w+");
			fwrite($fp,"<?php\r\n defined(\"td_erp\") or exit(\"Access Denied\");\r\n return ".var_export($this->row,true).";\r\n?>");
			fclose($fp);
		}
	}
	function query($sql="",$page=1,$pageSize=10,$pn=4,$fields="*",$useCache=true)
	{
		//参数说明：$page是当前要显示的第几页；$pageSize是每一页要显示多少条记录；$pn是当前页号前后各取几个值，默认前后各取4个值；$fields查询结果中需要保留的字段，默认全部保留
		//注意，这里SQL语句的格式是 select count(*) as aCount from tableName where 条件 order by 排序字段，后面不要加类似limit 0,10的记录筛选
		$this->row=NULL;
		$this->row=array();
		$this->sql=$sql;
		$this->page=$page;
		$this->pageSize=$pageSize;
		$fields=preg_replace("/[;\\f\\n\\r\\t\\v'\"#%]{1,}/","",$fields);
		$fields=empty($fields)?"*":$fields;
		$useCache=(is_bool($useCache) && $useCache===true)?true:false;
		
		//sql缓存
		$cacheTime=&$td_config['cacheTime'];
		if($useCache && is_numeric($cacheTime) && $cacheTime>0)//使用缓存
		{
			$this->cacheSql($this->sql);
			$this->row=NULL;
			$this->row=array();
			$this->row=readSqlCache(md5($this->sql));
			$rowCount=$this->recordCount=$this->row[0]["aCount"];
			if($rowCount)
			{
				$this->page=!is_numeric($this->page)?1:abs((integer)($this->page));
				$this->page=($this->page<1)?1:$this->page;
				$pageCount=$this->recordCount/$this->pageSize;
				$pageCount=(floor($pageCount)<$pageCount)?floor($pageCount)+1:$pageCount;
				$pageCount=$pageCount<1?1:$pageCount;
				$this->page=$this->page>$pageCount?$pageCount:$this->page;
				$this->pageSize=!is_numeric($this->pageSize)?10:abs((integer)($this->pageSize));
				$x=($this->page-1)*$this->pageSize;
				$sql=str_replace("count(*) as aCount",$fields,$this->sql)." limit {$x},".$this->pageSize;
				$this->cacheSql($sql);
				$this->row=NULL;
				$this->row=array();
				$this->row=readSqlCache(md5($sql));
			}
		}
		else//不使用缓存
		{
			$this->sqlQuery($this->sql,1);
			$this->recordCount=$rowCount=$this->row[0]["aCount"];
			if($rowCount)
			{
				$this->page=!is_numeric($this->page)?1:abs((integer)($this->page));
				$this->page=($this->page<1)?1:$this->page;
				$pageCount=$this->recordCount/$this->pageSize;
				$pageCount=(floor($pageCount)<$pageCount)?floor($pageCount)+1:$pageCount;
				$pageCount=$pageCount<1?1:$pageCount;
				$this->page=$this->page>$pageCount?$pageCount:$this->page;
				$this->pageSize=!is_numeric($this->pageSize)?10:abs((integer)($this->pageSize));
				$x=($this->page-1)*$this->pageSize;
				$sql=str_replace("count(*) as aCount",$fields,$this->sql)." limit {$x},".$this->pageSize;
				$this->sqlQuery($sql,1);
			}
		}
		if($rowCount==0)
		{
			$this->page=1;
			$this->recordCount=0;
			$pageCount=1;
			$this->row=NULL;
			$this->row=array();
		}
		else
		{
			$this->recordCount=$rowCount;
		}
		$this->setPage($this->pageSize,$this->page,$pageCount,$this->recordCount,$pn);
	}
	function setPage($pageSize,$page,$pageCount,$recordCount,$pn)
	{
		global $td_config;
		$uriArray=parse_url($td_config['webUri']);
		$uri=$td_config['webPath'].$td_config['webUri'];
		if($td_config['openHtml'] && is_numeric(stripos($uri,"list-")))//如果已经开启伪静态，而且是列表页，则执行伪静态的列表页分页
		{
			$firstUri=preg_replace("/\-{1}[0-9]*\.{1}htm/i","-1.htm",$uri);
			$lastUri=preg_replace("/\-{1}[0-9]*\.{1}htm/i","-{$pageCount}.htm",$uri);
			
			//此部分页代码与下面的第二部分分页代码任取其一
			//第一个方式的分页代码
			/*
			$pre=$page-1;
			$preUri=preg_replace("/[0-9]+\./","{$pre}.",$uri);
			$next=$page+1;
			$nextUri=preg_replace("/[0-9]+\./","{$next}.",$uri);
			if($pageCount==1)
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;第一页&nbsp;上一页&nbsp;下一页&nbsp;最后一页";
			}
			else if($pageCount==$page)
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;<a href=\"{$firstUri}\" target=\"_self\">第一页</a>&nbsp;<a href=\"{$preUri}\" target=\"_self\">上一页</a>&nbsp;下一页&nbsp;最后一页&nbsp;<input type=\"text\" name=\"pageNum\" id=\"pageNum\" value=\"{$page}\" size=\"4\" />";
			}
			else if($page==1)
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;第一页&nbsp;上一页&nbsp;<a href=\"{$nextUri}\" target=\"_self\">下一页</a>&nbsp;<a href=\"{$lastUri}\" target=\"_self\">最后一页</a>&nbsp;<input type=\"text\" name=\"pageNum\" id=\"pageNum\" value=\"{$page}\" size=\"4\" />";
			}
			else
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;<a href=\"{$firstUri}\" target=\"_self\">第一页</a>&nbsp;<a href=\"{$preUri}\" target=\"_self\">上一页</a>&nbsp;<a href=\"{$nextUri}\" target=\"_self\">下一页</a>&nbsp;<a href=\"{$lastUri}\" target=\"_self\">最后一页</a>";
			}
			*/
			//第一个方式的分页代码结束
			
			//第二个方式的分页代码
			$p1=$page-$pn;
			$p2=$page+$pn;
			$p1=$p1<1?1:$p1;
			$p2=$p2>$pageCount?$pageCount:$p2;
			
			$this->pageString="
			<style type=\"text/css\">
				.pageDiv{width:100%; height:auto;}
				.pageDiv span{border:1px #CAD9F0 solid; background:#DCEBF1; margin-right:4px;}
				.pageDiv a{background:#fff; border:1px #CAD9F0 solid; height:20px; line-height:20px; padding:0 4px; margin-right:4px; color:#535353;}
				.pageDiv a:hover{background:#E7EFF1;}
				.checked{background:#699;}
				#pageNum{height:14px; line-height:14px; padding:0px;}
			</style>
			<div class=\"pageDiv\"><span>{$this->recordCount}/{$pageCount}/{$page}</span><a href=\"{$firstUri}\" target=\"_self\">|&lt;&lt;</a>
			";
			
			for($i=$p1; $i<=$p2; $i++)
			{
				$checked=$page==$i?" style=\"background:#699; color:#FFF;\"":"";
				$temp=preg_replace("/[0-9]+\./","{$i}.",$uri);
				$this->pageString.="<a href=\"{$temp}\" {$checked} target=\"_self\">{$i}</a>";
			}
			$this->pageString.="<a href=\"{$lastUri}\" target=\"_self\">&gt;&gt;|</a></div>";
			//第二个方式的分页代码结束
			
		}
		else
		{
			$parameter=(isset($uriArray["query"]))?$uriArray["query"]:"";
			$parameter=preg_replace("/(&page=)[0-9]*/","",$parameter);
			$parameter=preg_replace("/(page=)[0-9]*/","",$parameter);
			$parameter=isNull($parameter)?"?page=":"?{$parameter}&page=";
			
			$uri="{$td_config['webPath']}{$uriArray['path']}{$parameter}";
			
			
			$firstUri=$uri."1";
			$lastUri=$uri.$pageCount;
			
			//此部分页代码与下面的第二部分分页代码任取其一
			//第一个方式的分页代码
			/*
			$preUri=$uri.($page-1);
			$nextUri=$uri.($page+1);
			if($pageCount==1)
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;第一页&nbsp;上一页&nbsp;下一页&nbsp;最后一页";
			}
			else if($pageCount==$page)
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;<a href=\"{$firstUri}\" target=\"_self\">第一页</a>&nbsp;<a href=\"{$preUri}\" target=\"_self\">上一页</a>&nbsp;下一页&nbsp;最后一页&nbsp;<input type=\"text\" name=\"pageNum\" id=\"pageNum\" value=\"{$page}\" size=\"4\" />&nbsp;<input type=\"button\" name=\"GO\" id=\"GO\" value=\" GO \" onclick=\"goPage();\" style=\"height:24px; width:34px;\" />";
			}
			else if($page==1)
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;第一页&nbsp;上一页&nbsp;<a href=\"{$nextUri}\" target=\"_self\">下一页</a>&nbsp;<a href=\"{$lastUri}\" target=\"_self\">最后一页</a>&nbsp;<input type=\"text\" name=\"pageNum\" id=\"pageNum\" value=\"{$page}\" size=\"4\" />&nbsp;<input type=\"button\" name=\"GO\" id=\"GO\" value=\" GO \" onclick=\"goPage();\" style=\"height:24px; width:34px;\" />";
			}
			else
			{
				$this->pageString="{$pageSize}/{$pageCount}/{$page}&nbsp;&nbsp;<a href=\"{$firstUri}\" target=\"_self\">第一页</a>&nbsp;<a href=\"{$preUri}\" target=\"_self\">上一页</a>&nbsp;<a href=\"{$nextUri}\" target=\"_self\">下一页</a>&nbsp;<a href=\"{$lastUri}\" target=\"_self\">最后一页</a>&nbsp;<input type=\"text\" name=\"pageNum\" id=\"pageNum\" value=\"{$page}\" size=\"4\" />&nbsp;<input type=\"button\" name=\"GO\" id=\"GO\" value=\" GO \" onclick=\"goPage();\" style=\"height:24px; width:34px;\" />";
			}
			*/
			//第一个方式的分页代码结束
			
			//第二个方式的分页代码
			$p1=$page-$pn;
			$p2=$page+$pn;
			$p1=$p1<1?1:$p1;
			$p2=$p2>$pageCount?$pageCount:$p2;
			
			$this->pageString="
			<style type=\"text/css\">
				.pageDiv{width:100%; height:auto;}
				.pageDiv span{border:1px #CAD9F0 solid; background:#DCEBF1; margin-right:4px;}
				.pageDiv a{background:#fff; border:1px #CAD9F0 solid; height:20px; line-height:20px; padding:0 4px; margin-right:4px; color:#535353;}
				.pageDiv a:hover{background:#E7EFF1;}
				.checked{background:#699;}
				#pageNum{height:14px; line-height:14px; padding:0px;}
			</style>
			<div class=\"pageDiv\"><span>{$this->recordCount}/{$pageCount}/{$page}</span><a href=\"{$firstUri}\" target=\"_self\">|&lt;&lt;</a>
			";
			
			for($i=$p1; $i<=$p2; $i++)
			{
				$checked=$page==$i?" style=\"background:#699; color:#FFF;\"":"";
				$this->pageString.="<a href=\"{$uri}{$i}\" {$checked} target=\"_self\">{$i}</a>";
			}
			$this->pageString.="<a href=\"{$lastUri}\" target=\"_self\">&gt;&gt;|</a><input type=\"text\" name=\"pageNum\" id=\"pageNum\" value=\"{$page}\" size=\"4\" />&nbsp;<input type=\"button\" name=\"GO\" id=\"GO\" value=\"GO\" onclick=\"goPage();\" style=\"width:42px; height:20px; text-align:center; line-height:15px; padding-top:0px;\" /></div>";
			//第二个方式的分页代码结束
			
			
			$this->pageString.="<script type=\"text/javascript\">
			function goPage()
			{
				var userPageNum=document.getElementById('pageNum').value; 
				userPageNum=userPageNum.replace(/[^0-9]/g,\"\");
				if(isNaN(userPageNum))
				{
					return false;
				}
				window.location.href=\"{$uri}\"+userPageNum;
			}
			</script>";
		}
	}
	
	function bbsQuery($sql="",$page=1,$pageSize=10,$pn=4,$fields="*",$useCache=true,$modId=0)
	{
		global $td_config;
		$this->query($sql,$page,$pageSize,$pn,$fields,$useCache);
		$pageString=$this->pageString;
		if($td_config['openHtml'] && is_numeric(stripos($td_config['webUri'],"list-")))//如果已经开启伪静态，而且是列表页，则执行伪静态的列表页分页
		{
			$pageString=preg_replace("/(.htm)/","-{$modId}.htm",$pageString);
		}
		$this->pageString=$pageString;
	}
}
?>

