<?php
!defined("td_erp")?exit("Access Deiend"):'';
class sys{
/*
	学校相关方法
*/
	//获取指定ID的学校
	static function getSchool(&$schoolList,$id=0,$onlyName=false){
		if(!is_array($schoolList) || !is_numeric($id)){
			return false;
		}
		foreach($schoolList as $s){
			if($s['id']==$id){
				return $onlyName?$s['school']:$s;
			}
		}
		return false;
	}
	//查询指定名称的学校是否存在
	static function checkSchool(&$schoolList,$school){
		if(!is_array($schoolList) || isNull($school)){
			return false;
		}
		foreach($schoolList as $s){
			if(strcasecmp($s['school'],$school)==0){
				return true;
			}
		}
		return false;
	}
	//生成学校SELECT
	static function schoolSelect(&$schoolList,$sName='',$sId='',$js='',$checkedId=0){
		if(!is_array($schoolList)){
			return false;
		}
		$sName=(isNull($sName) || !preg_match("/[a-z]{1,20}/i",$sName))?'schoolId':$sName;
		$sId=(isNull($sId) || !preg_match("/[a-z]{1,20}/i",$sId))?'schoolId':$sId;
		$checkedId=is_numeric($checkedId)?$checkedId:0;
		$onChange=isNull($js)?'':" onChange=\"{$js}\"";
		$select=<<<html
		<select name="{$sName}" id="{$sId}" {$onChange}><option value="-1">---请选择---</option>
html;
		foreach($schoolList as $s){
			$checked=$s['id']==$checkedId?' selected':'';
			if($s['id']=='4'){
				continue;
			}
			$select.=<<<html
			<option value="{$s['id']}" {$checked}>{$s['school']}</option>
html;
		}
		$select.="</select>";
		return $select;
	}
	//给出部门ID，获取此部门所属的学校
	static function getSchoolByUnit(&$schoolList,&$adminUnitList,$unitId=0,$onlyName=false){
		$unitId=(!is_numeric($unitId) || (int)($unitId)<1)?0:(int)($unitId);
		if(!is_array($schoolList) || $unitId<1){
			return false;
		}
		$result='';
		$result=self::getUnit($adminUnitList,$unitId);
		if(!is_array($result)){
			return false;
		}
		$result=self::getSchool($schoolList,$result['schoolId']);
		if(is_array($result)){
			return $onlyName?$result['school']:$result;
		}else{
			return false;
		}
	}
	
	
/*
	部门相关方法
*/
	//获取指定ID的部门
	static function getUnit(&$adminUnit,$id=0,$onlyName=false){
		if(!is_array($adminUnit) || !is_numeric($id)){
			return false;
		}
		foreach($adminUnit as $a){
			if($a['id']==$id){
				return $onlyName?$a['unitName']:$a;
			}
		}
		return false;
	}
	//获取指定部门的子部门列表
	static function getSubUnit(&$adminUnit,$id=0,$self=false){
		if(!is_array($adminUnit) || !is_numeric($id)){
			return false;
		}
		$result=array();
		
		if($self){
			$temp=self::getUnit($adminUnit,$id);
			if($temp==false){
				return false;
			}else{
				$result[]=$temp;
			}
		}
		foreach($adminUnit as $v){
			if($v['parentId']==$id){
				$result[]=$v;
				$temp=self::getSubUnit($adminUnit,$v['id'],false);
				if(is_array($temp) && count($temp)>0){
					foreach($temp as $t){
						$result[]=$t;
					}
				}
			}
		}
		return $result;
	}
	//获取指定部门的子部门ID列表
	static function getSubUnitId(&$adminUnit,$id=0,$self=false){
		if(!is_array($adminUnit) || !is_numeric($id)){
			return false;
		}
		$result=self::getSubUnit($adminUnit,$id,$self);
		if($result==false){
			return false;
		}else{
			$idList='';
			foreach($result as $v){
				$idList.="{$v['id']},";
			}
			$idList=trim($idList,',');
			return $idList;
		}
	}
	//获取指定学校ID的部门，不指定学校ID时，取出全部部门
	static function getUnitBySid(&$adminUnit,$id=0,$onlyName=false){
		if(!is_array($adminUnit)){
			return false;
		}
		$id=(!is_numeric($id) || $id<1)?0:$id;
		$result=array();
		if($id>0){
			foreach($adminUnit as $a){
				if($a['schoolId']==$id){
					$result[]=$onlyName?$a['unitName']:$a;
				}
			}
		}else{
			foreach($adminUnit as $a){
				$result[]=$onlyName?$a['unitName']:$a;
			}
		}
		return count($result)==0?false:$result;
	}
	//获取指定学校ID的部门ID列表，不指定学校ID时，取出全部部门的ID列表。与上一方法的区别是，此方法只取ID列表，之间用英文的逗号隔开
	static function getUnitIdList(&$adminUnit,$id=0){
		if(!is_array($adminUnit)){
			return false;
		}
		$result='';
		$temp=self::getUnitBySid($adminUnit,$id);
		if(is_array($temp)){
			foreach($temp as $t){
				$result.=$t['id'].',';
			}
		}
		$result=trim($result,',');
		return isNull($result)?false:$result;
	}
	//给出部门ID列表，获取部门数组
	static function getUnitList(&$adminUnit,$idList='',$onlyName=false){
		if(!is_array($adminUnit) || is_null($idList)){
			return false;
		}
		$idList=trim($idList,",");
		$idList=explode(',',$idList);
		$result=array();
		foreach($idList as $i){
			$temp=self::getUnit($adminUnit,$i);
			if(is_array($temp)){
				$result[]=$onlyName?$temp['unitName']:$temp;
			}
		}
		return count($result)==0?false:$result;
	}
	//获取顶级部门
	static function getTopUnit(&$adminUnit,$onlyName=false){
		if(!is_array($adminUnit)){
			return false;
		}
		$result=array();
		foreach($adminUnit as $a){
			if($a['parentId']==0 || !is_numeric($a['parentId'])){
				$result[]=$onlyName?$a['unitName']:$a;
			}
		}
		return count($result)==0?false:$result;
	}
	//获取指定ID部门的全部父部门，返回二维数组
	static function getParentUnit(&$adminUnit,$id=0,$onlyName=false){
		if(!is_array($adminUnit) || !is_numeric($id)){
			return false;
		}
		$result=array();
		foreach($adminUnit as $a){
			if(is_numeric(stripos($a['subId'],",{$id},"))){
				$result[]=$onlyName?$a['unitName']:$a;
			}
		}
		return count($result)==0?false:$result;
	}
	//生成部门SELECT，如果指定ID，则获取从指定ID开始的SELECT（从当前级别开始的向下级别），如果指定学校ID，则只生成指定学校的部门SELECT，否则，全部生成
	//$checkedId指定默认被选中的部门
	static function unitSelect($adminUnit,$sName='',$sId='',$js="",$schoolId=0,$checkedId=0,$id=0){
		global $schoolList;
		if(!is_array($adminUnit)){
			return false;
		}
		if(is_numeric($schoolId) && is_array(self::getSchool($schoolList,$schoolId))){
			$temp=array();
			foreach($adminUnit as $a){
				if($a['schoolId']==$schoolId){
					$temp[]=$a;
				}
			}
			$adminUnit=$temp;
			$temp=NULL;
		}
		$checkedId=!is_numeric($checkedId)?0:$checkedId;
		$space="";
		$onChange=isNull($js)?'':" onChange=\"{$js}\"";
		$select=<<<html
		<select name="{$sName}" id="{$sId}" {$onChange}><option value="-1">---请选择---</option>
html;
		if(is_numeric($id) && $id>0){
			self::exeUnitSelect($adminUnit,$id,$select,$space,$checkedId);
		}else{
			$topUnit=self::getTopUnit($adminUnit);
			foreach($topUnit as $t){
				$checked=$t['id']==$checkedId?" selected":"";
				$select.=<<<html
				<option value="{$t['id']}" {$checked}>{$space}{$t['unitName']}</option>
html;
				self::exeUnitSelect($adminUnit,$t['id'],$select,$space,$checkedId);
			}
		}
		$select.="</select>";
		return $select;
	}
	static function exeUnitSelect(&$adminUnit,$id,&$select,$space,$checkedId){
		if(!is_array($adminUnit) || !is_numeric($id)){
			return false;
		}
		$space.="　";
		foreach($adminUnit as $a){
			if($a['parentId']==$id){
				$checked=$a['id']==$checkedId?" selected":"";
				$select.=<<<html
				<option value="{$a['id']}" {$checked}>{$space}{$a['unitName']}</option>
html;
				if(!isNull(trim($a['subId'],','))){
					$temp=self::getUnitList($adminUnit,$a['subId']);
					if(is_array($temp)){
						foreach($temp as $t){
							if($t['parentId']==$a['id']){
								$checked=$t['id']==$checkedId?" selected":"";
								$space_2=$space.'　';
								$select.=<<<html
								<option value="{$t['id']}" {$checked}>{$space_2}{$t['unitName']}</option>
html;
							}else{
								self::exeUnitSelect($adminUnit,$t['id'],$select,$space,$checkedId);
							}
						}
					}
				}
				return;
			}
		}
	}
	
/*
	职位相关方法
*/
	//获取指定ID的职位
	static function getPosition(&$positionList,$id=0,$onlyName=false){
		if(!is_array($positionList)){
			return false;
		}
		$id=!is_numeric($id)?0:$id;
		foreach($positionList as $p){
			if($p['id']==$id){
				return $onlyName?$p['positionName']:$p;
			}
		}
		return false;
	}
	//获取指定部门的职位SELECT
	static function positionSelect(&$positionList,$unitId=0,$pName='',$pId='',$js='',$checkedId=0){
		if(!is_array($positionList) || !is_numeric($unitId) || (int)($unitId)<1){
			return false;
		}
		$unitId=(int)($unitId);
		$pName=!preg_match("/[a-z]{1,20}/i",$pName)?"positionId":$pName;
		$pId=!preg_match("/[a-z]{1,20}/i",$pName)?"positionId":$pName;
		$select=<<<html
		<select name="{$pName}" id="{$pId}" onChange="{$js}"><option value="-1">---请选择---</option>
html;
		foreach($positionList as $p){
			if($p['unitId']==$unitId){
				$checked=$p['id']==$checkedId?" selected":'';
				$select.="<option value=\"{$p['id']}\" {$checked}>{$p['positionName']}</option>";
			}
		}
		$select.="</select>";
		return $select;
	}
	
	//获取指定学校，指定名称的职位ID
	static function getPositionId(&$schoolId,$pName=''){
		global $adminUnit,$positionList;
		if(!is_numeric($schoolId) || isNull($pName)){
			return false;
		}
		$teacher=array();
		$i=0;
		foreach($positionList as $p){
			if($p['positionName']==$pName){
				$teacher[$i]['uId']=$p['unitId'];
				$teacher[$i]['pId']=$p['id'];
				$i++;
			}
		}
		foreach($adminUnit as $k=>$a){
			$i=0;
			foreach($teacher as $t){
				if($a['schoolId']==$schoolId && $t['uId']==$a['id']){
					return $teacher[$i]['pId'];
				}
				$i++;
			}
		}
		return false;
	}
	
/*
	仓库相关方法
*/
	//给出仓库的ID，获取仓库
	static function getWs($wsId=0,$onlyName=false){
		global $td_config;
		if(!is_numeric($wsId) || (int)($wsId)<=0){
			return false;
		}
		$row=getone("select * from {$td_config['pre']}wms where id={$wsId}",true);
		if(!is_array($row)){
			return false;
		}else{
			return $onlyName?$row['wsName']:$row;
		}
	}
	//返回仓库的SELECT
	static function wsSelect($schoolId=-1,$wsName="",$wsId="",$js="",$checked=""){
		global $td_config;
		$schoolId=(!is_numeric($schoolId) || (int)($schoolId)<0)?-1:(int)($schoolId);
		$wsName=preg_match("/^[a-zA-Z0-9_]{1,20}$/",$wsName)?$wsName:"wsId";
		$wsId=preg_match("/^[a-zA-Z0-9_]{1,20}$/",$wsId)?$wsId:"wsId";
		$js=!isNull($js)?" onchange=\"{$js}\"":'';
		$where=$schoolId==-1?" where 1":" where schoolId={$schoolId}";
		$row=query("select * from {$td_config['pre']}wms {$where} order by wsType",false);
		$select="<select name=\"{$wsName}\" id=\"{$wsId}\" {$js}><option value=\"-1\">---请选择---</option>";
		foreach($row as $r){
			$selected=$checked==$r['id']?" selected":'';
			$select.=<<<html
			<option value="{$r['id']}" {$selected}>{$r['wsName']}</option>
html;
		}
		$select.="</select>";
		return $select;
	}
	//返回仓库类型SELECT
	static function wsTypeSelect($schoolId=-1,$wsTypeName="",$wsTypeId="",$js="",$checked=""){
		global $td_config;
		$schoolId=(!is_numeric($schoolId) || (int)($schoolId)<0)?-1:(int)($schoolId);
		$wsTypeName=preg_match("/^[a-zA-Z0-9_]{1,20}$/",$wsTypeName)?$wsTypeName:"wsTypeName";
		$wsTypeId=preg_match("/^[a-zA-Z0-9_]{1,20}$/",$wsTypeId)?$wsTypeId:"wsTypeName";
		$js=!isNull($js)?" onchange=\"{$js}\"":'';
		$where=$schoolId==-1?" where 1":" where schoolId={$schoolId}";
		$row=query("select distinct(wsType) as wsType from {$td_config['pre']}wms {$where} order by wsType",false);
		$select="<select name=\"{$wsTypeName}\" id=\"{$wsTypeId}\" {$js}><option value=\"-1\">---请选择---</option>";
		foreach($row as $r){
			$selected=$checked==$r['wsTypeName']?" selected":'';
			$select.=<<<html
			<option value="{$r['wsType']}">{$r['wsType']}</option>
html;
		}
		$select.="</select>";
		return $select;
	}
	
/*
	餐厅相关操作
*/
	//由学校的ID获取设立的餐厅SELECT，不传递学校ID则取出所有的餐厅
	static function ctSelect($schoolId=-1,$ctName='',$ctId='',$js='',$checked=-1){
		global $td_config,$query;
		$ctName=isNull($ctName)?"ctName":$ctName;
		$ctId=isNull($ctId)?"ctId":$ctId;
		if(!is_numeric($schoolId) || (int)($schoolId)<0){
			$sql="select * from {$td_config['pre']}canting";
		}else{
			$sql="select * from {$td_config['pre']}canting where schoolId={$schoolId}";
		}
		$query->query($sql,1,false);
		$select="<select name=\"{$ctName}\" id=\"{$ctId}\" {$js}><option value=\"-1\">---请选择---</option>";
		foreach($query->row as $q){
			$selected=$checked==$q['id']?" selected":'';
			$select.=<<<html
			<option value="{$q['id']}">{$q['ctName']}</option>
html;
		}
		$select.="</select>";
		return $select;
	}
	
	//由餐厅的ID，获取餐厅的信息，$isName为true时只返回餐厅名称，否则返回指定餐厅的一维数组。
	static function getCtById($ctId=-1,$onlyName=false){
		global $td_config;
		if(!is_numeric($ctId)){
			return false;
		}
		$sql="select * from {$td_config['pre']}canting where id={$ctId}";
		$row=getone($sql,true);
		$result=$onlyName?$row['ctName']:$row;
		return $result;
	}
	
	//经出学校ID、年级、班级，获取就餐的餐厅
	static function getCt($schoolId=-1,$gradeId=-1,$classId=-1,$onlyName=false){
		global $td_config;
		if(!is_numeric($schoolId) || !is_numeric($gradeId) || !is_numeric($classId)){
			return false;
		}
		$sql="select * from {$td_config['pre']}classcanting where schoolId={$schoolId} and gradeId={$gradeId} and classId={$classId}";
		$row=getone($sql,true);
		if(!is_array($row)){
			return false;
		}else{
			$ct=$onlyName?self::getCtById($row['ctId'],true):self::getCtById($row['ctId'],false);
			return $ct;
		}
	}
}
?>