<?php
!defined('td_erp')?exit('Access Denied'):'';
/*
	会员信息相关类及函数
*/
class user{
	public $userNick;
	public $zz_userNick;
	function __construct($zz_userNick){
		global $zz_userNick;
		$this->zz_userNick=$zz_userNick;
	}
	//检测给出的账号是否合法
	function checkUserNick($userNick=''){
		if(isNull($userNick) || !preg_match($this->zz_userNick,$userNick)){
			return false;
		}else{
			return true;
		}
	}
	//检测给出的账号是否已经存在
	function existsUserNick($userNick=''){
		global $td_config;
		if(isNull($userNick) || !preg_match($this->zz_userNick,$userNick)){
			return false;
		}else{
			$row=getone("select id from {$td_config['pre']}user where userNick='{$userNick}'",false);
			if(is_array($row)){
				return true;
			}else{
				return false;
			}
		}
	}
	//赋空值则查询所有的账号，以分页的方式返回，$userNick传递要查询的账号；$cache是否使用查询缓存；当userNick为空或不合法时，$perPage值用来确定每页返回的记录数量
	function  queryUser($userNick='',$cache=false,$page=1,$perPage=20){
		global $td_config,$pageObj;
		$cache=$cache?true:false;
		$page=(!is_numeric($page) || $page<1)?1:(int)($page);
		$perPage=(!is_numeric($perPage) || $perPage<1 || $perPage>1000)?20:(int)($perPage);
		$where=" where 1";
		if($this->checkUserNick($userNick)){
			$row=getone("select * from {$td_config['pre']}user where userNick='{$userNick}'",$cache);
			return $row;
		}else{
			$pageObj->query("select count(*) as aCount from {$td_config['pre']}user order by id desc","{$page}",$perPage,4,"*",$cache);
			return $pageObj;
		}
	}
	//查询教职工信息，赋空值则查询所有的账号，以分页的方式返回，$userNick传递要查询的账号；$cache是否使用查询缓存；当userNick为空或不合法时，$perPage值用来确定每页返回的记录数量
	function  queryTeacher($userNick='',$cache=false,$page=1,$perPage=20){
		global $td_config,$pageObj;
		$cache=$cache?true:false;
		$page=(!is_numeric($page) || $page<1)?1:(int)($page);
		$perPage=(!is_numeric($perPage) || $perPage<1 || $perPage>1000)?20:(int)($perPage);
		$where=" where 1";
		if($this->checkUserNick($userNick)){
			$row=getone("select * from {$td_config['pre']}teachers where userNick='{$userNick}'",$cache);
			return $row;
		}else{
			$pageObj->query("select count(*) as aCount from {$td_config['pre']}teachers order by id desc","{$page}",$perPage,4,"*",$cache);
			return $pageObj;
		}
	}
	//检测给出账号的登录状态，处于登录状态时返回在线状态的一维数组；不在线时，返回FALSE
	function checkLogined($userNick){
		global $td_config;
		if($this->checkUserNick($userNick)){
			$row=getone("select * from {$td_config['pre']}online where userNick='{$userNick}'",false);
			if(is_array($row)){
				return $row;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	
	//检测给出的账号是否有跨学校管理或浏览的权限，不给出账号时，默认为当前账号
	function kxAdmin($userNick=''){
		global $td_config,$td_online,$zz_userNick;
		$userNick=(isNull($userNick) || !preg_match($zz_userNick,$userNick))?$td_online['userNick']:$userNick;
		if($userNick!=$td_online['userNick'] && $userNick!='admin'){
			$row=getone("select * from {$td_config['pre']}user where userNick='{$userNick}'",true);
			if(!is_array($row) || !isset($row['kxList']) || $row['kxList']!='1'){
				return false;
			}else{
				return true;
			}
		}else if((isset($td_online['kxList']) && $td_online['kxList']=='1') || $userNick=='admin'){
			return true;
		}else{
			return false;
		}
	}
	
	//清除已经登录超时用户的在线状态，并更新当前用户的刷新时间
	function clearLogined(){
		global $td_config,$td_online,$zz_userNick;
		myupdate("delete from {$td_config['pre']}online where date_add(refreshTime,interval {$td_config['timeoutLogined']} SECOND)<now()");
		if(preg_match($zz_userNick,$td_online['userNick'])){
			$row=getone("select userNick from {$td_config['pre']}online where userNick='{$td_online['userNick']}' and loginKey='{$td_online['loginKey']}'",false);
			if(is_array($row)){
				myupdate("update {$td_config['pre']}online set refreshTime='{$td_config['dateTime']}' where userNick='{$td_online['userNick']}'");
			}else{
				myupdate("delete from {$td_config['pre']}online where userNick='{$td_online['userNick']}'");
				$td_online=array('userNick'=>'','loginTime'=>'','loginKey'=>'');
				$_SESSION['userNick']=NULL;
				$_SESSION['loginTime']=NULL;
				$_SESSION['loginKey']=NULL;
			}
		}
	}
	
	//检测用户是否有指定模块的管理权限
	function checkModuleAdmin($userNick='',$moduleId=0){
		global $td_config;
		if(!is_numeric($moduleId)){
			return false;
		}
		$moduleId=abs((int)($moduleId));
		if($this->checkUserNick($userNick)){
			if(strcasecmp('admin',$userNick)==0){
				return true;
			}
			$row=getone("select id from {$td_config['pre']}admin where userNick='{$userNick}' and moduleId={$moduleId}",false);
			if(is_array($row)){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	
	//检测用户是否有指定模块的指定管理方式的管理权限
	function checkModuleOperation($userNick='',$moduleId=0,$operation=''){
		global $td_config,$zz_userNick;
		if(!preg_match($zz_userNick,$userNick) || !is_numeric($moduleId)){
			return false;
		}
		$moduleId=abs((int)($moduleId));
		if($this->checkUserNick($userNick)){
			if(strcasecmp('admin',$userNick)==0){
				return true;
			}
			$row=$this->getUserOperation($userNick,$moduleId);
			if(is_array($row)){
				$row=explode(',',trim($row['operate'],','));
				$operation=strtolower($operation);
				foreach($row as $r){
					if(is_numeric(stripos($operation,$r))){
						return true;
					}
				}
				return false;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	
	//获取指定用户对模块已拥有的操作权限，$moduleId传递模块的ID，如果不传递此值，则获取指定工号对所有模块的可操作数组
	function getUserOperation($userNick='',$moduleId=0){
		global $td_config;
		if(!$this->checkUserNick($userNick)){
			return false;
		}
		$moduleId=(!is_numeric($moduleId) || (int)($moduleId)<1)?0:(int)($moduleId);
		if($moduleId==0){
			$row=query("select operate from {$td_config['pre']}admin where userNick='{$userNick}'",false);
		}else{
			$row=getone("select operate from {$td_config['pre']}admin where userNick='{$userNick}' and moduleId={$moduleId}",false);
		}
		return is_array($row)?$row:false;
	}
	
	//构造学历SELECT
	function xueLi($name='',$id='',$js='',$checkedId=''){
		$name=!preg_match("/[a-z0-9]{1,20}/i",$name)?'eduBackground':$name;
		$id=!preg_match("/[a-z0-9]{1,20}/i",$id)?'eduBackground':$id;
		$xueLi=array('院士','博士后','博士','硕士','本科','大专','中专','高中','初中','小学','其它');
		$select=<<<html
		<select name="{$name}" id="{$id}" onChange="{$js}"><option value="0">---请选择---</option>
html;
		foreach($xueLi as $x){
			$checked=$checkedId==$x?" selected":'';
			$select.="<option value=\"{$x}\" {$checked}>{$x}</option>";
		}
		$select.="</select>";
		return $select;
	}
	
	//构造政治面貌
	function zzmm($name='',$id='',$js='',$checkedId=''){
		$name=!preg_match("/[a-z0-9]{1,20}/i",$name)?'eduBackground':$name;
		$id=!preg_match("/[a-z0-9]{1,20}/i",$id)?'eduBackground':$id;
		$xueLi=array('群众','团员','预备党员','党员','其它民主党派');
		$select=<<<html
		<select name="{$name}" id="{$id}" onChange="{$js}">
html;
		foreach($xueLi as $x){
			$checked=$checkedId==$x?" selected":'';
			$select.="<option value=\"{$x}\" {$checked}>{$x}</option>";
		}
		$select.="</select>";
		return $select;
	}
	
	//县乡镇村SELECT
	function xxzc($name='',$id='',$parentId=0,$js='',$checkedId=''){
		global $td_config;
		if(!preg_match("/^[a-z0-9_]{1,20}$/i",$name) || !preg_match("/^[a-z0-9_]{1,20}$/i",$id)){
			return false;
		}
		$parentId=!is_numeric($parentId)?0:(int)($parentId);
		$row=readCache("areasmall.php");
		$select=<<<html
		<select name="{$name}" id="{$id}" onChange="{$js}"><option value="-1">---请选择---</option>
html;
		if(is_array($row)){
			foreach($row as $v){
				if($v['parentId']==$parentId){
					$select.="<option value=\"{$v['areaId']}\">{$v['areaName']}</option>";
				}
			}
		}
		$select.="</select>";
		return $select;
	}
	
	//身份证号码验证
	function validation_filter_id_card($id_card) 
	{ 
		if(strlen($id_card) == 18) 
		{ 
			return $this->idcard_checksum18($id_card); 
		} 
		elseif((strlen($id_card) == 15)) 
		{ 
			$id_card = $this->idcard_15to18($id_card); 
			return $this->idcard_checksum18($id_card); 
		} 
		else 
		{ 
			return false; 
		} 
	} 
	// 计算身份证校验码，根据国家标准GB 11643-1999 
	function idcard_verify_number($idcard_base) 
	{ 
		if(strlen($idcard_base) != 17) 
		{ 
		return false; 
		} 
		//加权因子 
		$factor = array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2); 
		//校验码对应值 
		$verify_number_list = array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2'); 
		$checksum = 0; 
		for ($i = 0; $i < strlen($idcard_base); $i++) 
		{ 
			$checksum += substr($idcard_base, $i, 1) * $factor[$i]; 
		} 
		$mod = $checksum % 11; 
		$verify_number = $verify_number_list[$mod]; 
		return $verify_number; 
	} 
	// 将15位身份证升级到18位 
	function idcard_15to18($idcard){ 
		if (strlen($idcard) != 15){ 
			return false; 
		}else{ 
		// 如果身份证顺序码是996 997 998 999，这些是为百岁以上老人的特殊编码 
			if (array_search(substr($idcard, 12, 3), array('996','997','998','999')) !== false){
				$idcard = substr($idcard, 0, 6) . '18'. substr($idcard,6,9);
			}else{ 
				$idcard = substr($idcard, 0, 6) . '19'. substr($idcard,6,9);
			} 
		} 
		$idcard = $idcard.$this->idcard_verify_number($idcard);
		return $idcard; 
	} 
	// 18位身份证校验码有效性检查 
	function idcard_checksum18($idcard){
		if(strlen($idcard) != 18){return false; }
			$idcard_base = substr($idcard,0,17);
		if($this->idcard_verify_number($idcard_base) != strtoupper(substr($idcard, 17, 1))){
			return false;
		}else{
			return true;
		}
	}
}
?>