<?php
!defined("td_erp")?exit("Access Denied"):'';
class ws_category{
	//获取指定的分类
	static function getCategory(&$catList,$id=0,$onlyName=false){
		if(!is_array($catList)){
			return false;
		}
		if(!is_numeric($id) || $id<1){
			if($onlyName){
				$result=array();
				foreach($catList as $c){
					$result[]=$c['catName'];
				}
				return $result;
			}else{
				return $catList;
			}
		}else{
			$id=(int)($id);
			foreach($catList as $c){
				if($c['id']==$id){
					return $onlyName?$c['catName']:$c;
				}
			}
			return false;
		}
	}
	
	//获取指定分类的所有父分类
	static function getParent(&$catList,$id=0,$self=true){
		if(!is_array($catList) || !is_numeric($id) || $id<1){
			return false;
		}
		foreach($catList as $c){
			if(is_numeric(strpos($c["subId"],",{$id},")))
			{
				$temp[]=$c;
			}
		}
		if($self){
			foreach($catList as $c){
				if($c['id']==$id){
					$temp[]=$c;
					break;
				}
			}
		}
		return $temp;
	}
	
	//给出ID列表，得出对应的分类，返回二维数组
	static function getCatByIdList(&$catList,$idList='',$onlyName=false){
		if(!is_array($catList)){
			return false;
		}
		$idList=trim($idList,',');
		$idList=explode(',',$idList);
		if(count($idList)){
			if($onlyName){
				$result='';
				foreach($catList as $c){
					$result=in_array($c['id'],$idList)?",{$c['catName']}":'';
				}
				$result=trim($result,',');
			}else{
				$result=array();
				foreach($catList as $c){
					if(in_array($c['id'],$idList)){
						$result[]=$c;
					}
				}
			}
			return $result;
		}else{
			return false;
		}
	}
	
	//获取顶级分类
	static function getTopCat(&$catList){
		if(!is_array($catList)){
			return false;
		}
		$result=array();
		foreach($catList as $c){
			if($c['parentId']=='0'){
				$result[]=$c;
			}
		}
		return $result;
	}
	
	//构造分类SELECT
	static function catSelect(&$catList,$name='',$id='',$js='',$checkedId=0){
		if(!is_array($catList)){
			return false;
		}
		$name=!preg_match("/[a-z]{1,20}/i",$name)?'catId':$name;
		$id=!preg_match("/[a-z]{1,20}/i",$id)?'catId':$id;
		$onChange=isNull($js)?'':" onChange=\"{$js}\"";
		$checkedId=!is_numeric($checkedId)?0:(int)($checkedId);
		$topCat=self::getTopCat($catList);
		$select=<<<html
		<select name="{$name}" id="{$id}" {$onChange}><option value="-1">---请选择---</option>
html;
		foreach($topCat as $t){
			$space='　';
			$selected=$checkedId==$t['id']?" selected":'';
			$select.="<option value=\"{$t['id']}\" {$selected}>{$t['catName']}</option>";
			$select.=self::cateSelectSub($catList,$t['id'],$space);
		}
		$select.="</select>";
		return $select;
	}
	static function cateSelectSub(&$catList,$id=0,$space=''){
		if(!is_array($catList)){
			return '';
		}
		$space.='　';
		$result='';
		foreach($catList as $c){
			if((int)($c['parentId'])==$id){
				$result.="<option value=\"{$c['id']}\">{$space}{$c['catName']}</option>";
				$result.=self::cateSelectSub($catList,$c['id'],$space);
				return $result;
			}
		}
		return $result;
	}
}
?>